#!/usr/local/bin/ruby -w

$input =STDIN
$output = STDOUT
if ARGV.size > 0
  ARGV.each do |arg|
    case arg
    when nil
    else
      $input = File.open(arg, 'r')
    end
  end
end

def set_octave( octave, old_octave )
 if octave > old_octave
   return '>'
 end
 if octave < old_octave
   return '<'
 end
 return ''
end

while (raw = $input.gets)
p raw
  octave = 0
  old_octave = 0
  prefix = nil
  tune = "l10"
  0.upto( raw.size ) do |i|
   ch = raw[i..i]
   case ch
   when 'C', 'D', 'E', 'F', 'G', 'A', 'B'
     octave -= 1
     tune << set_octave( octave, old_octave )
     old_octave = octave
     octave = 0
     tune << ch
     case prefix
     when '&'
       tune << '-'
       prefix = nil
     when '#'
       tune << '#'
     prefix = nil
     end
   when 'c', 'd', 'e', 'f', 'g', 'a', 'b'
     tune << set_octave( octave, old_octave )
     old_octave = octave
     octave = 0
     tune << ch
     case prefix
     when '&'
       tune << '-'
       prefix = nil
     when '#'
       tune << '#'
       prefix = nil
     end
   when 'P', 'p'
     tune << '.'
   when '#'
     # unknown
   when '+'
     octave += 1
   when "\n"
     tune << set_octave( octave, old_octave )
     puts tune
     `echo '#{tune}' > /dev/speaker`
   else
     tune << ch
   end
  end
end

exit 0
# in:
# "eaebegae+ce+deb+cebeaebegae+ce+deb+c\n"
# out: 
# "l12<eaebegae>c<e>d<eb>c<eaebegae>c<e>d<eb>c<ebe"
# eof
